require 'rails_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to specify the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator.  If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails.  There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.
#
# Compared to earlier versions of this generator, there is very limited use of
# stubs and message expectations in this spec.  Stubs are only used when there
# is no simpler way to get a handle on the object needed for the example.
# Message expectations are only used when there is no simpler way to specify
# that an instance is receiving a specific message.
#
# Also compared to earlier versions of this generator, there are no longer any
# expectations of assigns and templates rendered. These features have been
# removed from Rails core in Rails 5, but can be added back in via the
# `rails-controller-testing` gem.

RSpec.describe Api::V1::CompaniesController, type: :controller do

  # This should return the minimal set of attributes required to create a valid
  # Api::V1::Company. As you add validations to Api::V1::Company, be sure to
  # adjust the attributes here as well.
  let(:valid_attributes) {
    {
      :name => 'Test LTDA',
      :slug => 'Test_ltda',
    }
  }

  let(:invalid_attributes) {
    {
      :name => 'Test LTDA'
    }
  }

  # This should return the minimal set of values that should be in the session
  # in order to pass any filters (e.g. authentication) defined in
  # Api::V1::CompaniesController. Be sure to keep this updated too.
  let(:valid_session) {{}}

  describe "authentication user" do

      login_user
 
    describe "POST #create" do

      context "with valid params" do

        it "renders a JSON response with the new api_v1" do

          post :create, params: {company: valid_attributes,format: :json}, session: valid_session
          expect(response).to have_http_status(:created)
          expect(response.content_type).to eq('application/json')
          expect(response.location).to eq(api_v1_company_url(Company.last))
        end
      end

      context "with invalid params" do
        it "renders a JSON response with errors for the new api_v1" do

          post :create, params: {company: invalid_attributes, format: :json}, session: valid_session
          expect(response).to have_http_status(:unprocessable_entity)
          expect(response.content_type).to eq('application/json')
        end
      end
    end

    describe "GET #index" do
      it "returns a success response" do
        company = FactoryBot.create(:company)
        get :index, params: {format: :json}, session: valid_session
        expect(response).to be_success
      end
    end

    describe "GET #show" do
      it "returns a success response" do
        company = FactoryBot.create(:company)
        get :show, params: {id: company.id.to_s, format: :json}, session: valid_session
        expect(response).to be_success
      end
    end
  end
end
